unit timethr;

interface

uses
  Classes;

type
  TTimeThread = class(TThread)
  private
    { Private-Deklarationen }
  protected
    procedure Execute; override;
  end;

implementation
uses Windows;

{ Wichtig: Methoden und Eigenschaften eines Objekts in der VCL
           knnen nur in einem Methodenaufruf mit SYNCHRONIZE
           genutzt werden, z.B.

      Synchronize(UpdateCaption);

  und UpdateCaption knnte sein,

    procedure TTimeThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in einem Thread';
    end; }

{ TTimeThread }

procedure TTimeThread.Execute;
type
  Feld = Array[1..5000000] of Byte;
var
  x: Extended;
  P: ^Feld;
  i: Integer;
  Mem: Integer;
begin
  { Plazieren Sie den Thread code hier }
  x := 12.75;
  Priority := tpHigher;
  Mem := GlobalAlloc(GMEM_FIXED, 5000000);
  p := Ptr(Mem);
  i := 1;
  while true do
  begin
    x := x*x*x - sqrt(x) + sin(x) + cos(x);
    x := 1/x;
    x := x + 3.75;
    P^[i] := trunc(x) + p^[1] + p^[1000000]+ p^[5000000];
    Inc(i);
    if i = 5000000 then i := 1;
    if Terminated then Break;
  end;
  GlobalFree(Mem);
end;

end.




